﻿using LibXom.Data;
using LibXom.Streams;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace LibW4M.Data.Schemes
{
    public class WeaponSettingsData : SaveDataEntry
    {
        public int Ammo;
        public int Crate;
        public int Delay;

        public WeaponSettingsData(W4SaveFile fileBelongs, XomContainer mainContainer) : base(fileBelongs, mainContainer)
        {
        }

        public override void Load()
        {
            using (XomStreamReader reader = new XomStreamReader(new MemoryStream(this.mainContainer.GetData())))
            {
                reader.Skip(3);
                this.Ammo = reader.ReadInt32();
                this.Crate = reader.ReadInt32();
                this.Delay = reader.ReadInt32();
            }
        }

        public override void Save()
        {
            using (MemoryStream ms = new MemoryStream())
            {
                using (XomStreamWriter writer = new XomStreamWriter(ms))
                {
                    writer.Skip(3);
                    writer.WriteInt32(this.Ammo);
                    writer.WriteInt32(this.Crate);
                    writer.WriteInt32(this.Delay);

                    ms.Seek(0x00, SeekOrigin.Begin);
                    mainContainer.SetData(ms.ToArray());
                }
            }
        }
    }
}
