﻿using LibW4M.Data.Highscores;
using LibW4M.Data.Schemes;
using LibW4M.Data.Teams;
using LibW4M.Data.WeaponFactory;
using LibW4M.Data.WXFE.UnlockableItem;
using W4Gui.Dialogs;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Windows.Forms.VisualStyles;

namespace W4Gui.Components
{
    public partial class UnlockableItemsPanel : UserControl
    {
        public UnlockableItemsPanel()
        {
            InitializeComponent();
        }

        public void LoadUnlockableItem(UnlockableItemData unlockableItem)
        {
            this.selType.Value = unlockableItem.Type;
            this.selState.Value = unlockableItem.State;
            this.selDescriptionName.Text = unlockableItem.DescriptionName.Value;
            this.selValue.Value = unlockableItem.Value;
            this.selUnlockRequirements.LoadData(DataManager.SaveFile.XomStringArrayToStringArray(unlockableItem.UnlockRequirements));
            this.selUnlockRequirementsMet.Checked = unlockableItem.UnlockRequirementsMet;
        }

        public void SaveUnlockableItem(ref UnlockableItemData unlockableItem)
        {
            unlockableItem.Type = this.selType.Value;
            unlockableItem.State = this.selState.Value;
            unlockableItem.DescriptionName = DataManager.SaveFile.LookupString(this.selDescriptionName.Text);
            unlockableItem.Value = this.selValue.Value;
            unlockableItem.UnlockRequirements = DataManager.SaveFile.StringArrayToXomStringArray(this.selUnlockRequirements.Items);
            unlockableItem.UnlockRequirementsMet = this.selUnlockRequirementsMet.Checked;
        }
    }
}
