﻿using LibW4M.Data.InputMapping;
using LibW4M.Data.Teams;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace W4Gui.Tabs
{
    public partial class InputEventMappingTab : TabEntry
    {
        public InputEventMappingTab()
        {
            InitializeComponent();
            this.inputEventMappingList.List.Selected += inputEventMappingList_Selected;
            this.inputEventMappingList.List.Unselected += inputEventMappingList_Unselected;

        }

        public override void SaveFromControl()
        {
            if (this.inputEventMappingList.List.IsItemSelected)
                inputEventMappingList_Unselected(null, null);
        }

        public override void LoadIntoControl()
        {
            this.inputEventMappingList.List.LoadCollective(DataManager.SaveFile.InputMappingCollective);
            inputEventMappingPanel.Enabled = false;
        }

        private void inputEventMappingList_Unselected(object? sender, EventArgs e)
        {
            InputEventMappingData InputEventMappingData = DataManager.SaveFile.InputMappingCollective[inputEventMappingList.List.LastSelected] as InputEventMappingData;
            inputEventMappingPanel.SaveInputEventMappingsData(ref InputEventMappingData);
            inputEventMappingList.List.UpdateName(inputEventMappingList.List.LastSelected, InputEventMappingData.FriendlyName);
        }

        private void inputEventMappingList_Selected(object? sender, EventArgs e)
        {
            InputEventMappingData InputEventMappingData = DataManager.SaveFile.InputMappingCollective[inputEventMappingList.List.CurrentlySelected] as InputEventMappingData;
            inputEventMappingPanel.LoadInputEventMappingsData(InputEventMappingData);
            inputEventMappingPanel.Enabled = true;
        }

        private void inputEventMappingList_NewButton(object sender, EventArgs e)
        {
            throw new NotImplementedException("Adding new inputEventMapping from here not implemented yet ;)");
        }

        private void inputEventMappingList_DelButton(object sender, EventArgs e)
        {
            throw new NotImplementedException("Removing inputEventMapping from here not implemented yet ;)");
        }

    }
}
