﻿using LibW4M.Data.Teams;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace W4Gui.Tabs
{
    public partial class TeamsTab : TabEntry
    {
        public TeamsTab()
        {
            InitializeComponent();
            this.teamsList.List.Selected += teamsList_Selected;
            this.teamsList.List.Unselected += teamsList_Unselected;

        }

        public override void SaveFromControl()
        {
            if (teamsList.List.IsItemSelected)
                teamsList_Unselected(null, null);
        }

        public override void LoadIntoControl()
        {
            this.teamsList.List.LoadCollective(DataManager.SaveFile.TeamDataColective);
            teamsPanel.Enabled = false;
        }

        private void teamsList_Unselected(object? sender, EventArgs e)
        {
            TeamData team = DataManager.SaveFile.TeamDataColective[teamsList.List.LastSelected] as TeamData;
            teamsPanel.SaveTeamData(ref team);
            teamsList.List.UpdateName(teamsList.List.LastSelected, team.Name.Value);
        }

        private void teamsList_Selected(object? sender, EventArgs e)
        {
            TeamData team = DataManager.SaveFile.TeamDataColective[teamsList.List.CurrentlySelected] as TeamData;
            teamsPanel.LoadTeamData(team);
            teamsPanel.Enabled = true;
        }

        private void teamsList_NewButton(object sender, EventArgs e)
        {
            throw new NotImplementedException("Adding new teams from here not implemented yet ;)");
        }

        private void teamsList_DeleteButton(object sender, EventArgs e)
        {
            throw new NotImplementedException("Removing weapons from here not implemented yet ;)");
        }

    }
}
