﻿using LibW4M.Data.Highscores;
using LibW4M.Data.Teams;
using LibW4M.Data.X;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace W4Gui.Tabs.VariablesTab
{
    public partial class IntVariablesTab : TabEntry
    {
        public IntVariablesTab()
        {
            InitializeComponent();
            this.variablesList.List.Selected += variablesList_Selected;
            this.variablesList.List.Unselected += variablesList_Unselected;

        }

        public override void SaveFromControl()
        {
            if (this.variablesList.List.IsItemSelected)
                variablesList_Unselected(null, null);
        }

        public override void LoadIntoControl()
        {
            this.variablesList.List.LoadArray(DataManager.SaveFile.XDataBank.IntResourceDetails);
            variablePanel.Enabled = false;
        }

        private void variablesList_Unselected(object? sender, EventArgs? e)
        {
            IntResourceDetail variableData = DataManager.SaveFile.XDataBank.IntResourceDetails[variablesList.List.LastSelected] as IntResourceDetail;
            variablePanel.SaveResourceData(ref variableData);
            variablesList.List.UpdateName(variablesList.List.LastSelected, variableData.FriendlyName);
        }

        private void variablesList_Selected(object? sender, EventArgs? e)
        {
            IntResourceDetail variableData = DataManager.SaveFile.XDataBank.IntResourceDetails[variablesList.List.CurrentlySelected] as IntResourceDetail;
            variablePanel.LoadResourceData(variableData);
            variablePanel.Enabled = true; 
        }

        private void variablesList_NewButton(object sender, EventArgs e)
        {
            throw new NotImplementedException("Adding new variables from here not implemented yet ;)");
        }

        private void variablesList_DelButton(object sender, EventArgs e)
        {
            throw new NotImplementedException("Removing variables from here not implemented yet ;)");
        }

    }
}
